diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_german.c b/src/backend/snowball/libstemmer/stem_UTF_8_german.c
index 5d406e5092..1a8b5924b4 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_german.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_german.c
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #include "header.h"
 
@@ -36,12 +36,12 @@ static const symbol s_0_5[2] = { 0xC3, 0xBC };
 
 static const struct among a_0[6] =
 {
-/*  0 */ { 0, 0, -1, 6, 0},
+/*  0 */ { 0, 0, -1, 5, 0},
 /*  1 */ { 1, s_0_1, 0, 2, 0},
 /*  2 */ { 1, s_0_2, 0, 1, 0},
 /*  3 */ { 2, s_0_3, 0, 3, 0},
 /*  4 */ { 2, s_0_4, 0, 4, 0},
-/*  5 */ { 2, s_0_5, 0, 5, 0}
+/*  5 */ { 2, s_0_5, 0, 2, 0}
 };
 
 static const symbol s_1_0[1] = { 'e' };
@@ -54,13 +54,13 @@ static const symbol s_1_6[2] = { 'e', 's' };
 
 static const struct among a_1[7] =
 {
-/*  0 */ { 1, s_1_0, -1, 1, 0},
+/*  0 */ { 1, s_1_0, -1, 2, 0},
 /*  1 */ { 2, s_1_1, -1, 1, 0},
-/*  2 */ { 2, s_1_2, -1, 1, 0},
+/*  2 */ { 2, s_1_2, -1, 2, 0},
 /*  3 */ { 3, s_1_3, -1, 1, 0},
 /*  4 */ { 2, s_1_4, -1, 1, 0},
-/*  5 */ { 1, s_1_5, -1, 2, 0},
-/*  6 */ { 2, s_1_6, 5, 1, 0}
+/*  5 */ { 1, s_1_5, -1, 3, 0},
+/*  6 */ { 2, s_1_6, 5, 2, 0}
 };
 
 static const symbol s_2_0[2] = { 'e', 'n' };
@@ -114,168 +114,160 @@ static const unsigned char g_st_ending[] = { 117, 30, 4 };
 
 static const symbol s_0[] = { 0xC3, 0x9F };
 static const symbol s_1[] = { 's', 's' };
-static const symbol s_2[] = { 'u' };
-static const symbol s_3[] = { 'U' };
+static const symbol s_2[] = { 'U' };
+static const symbol s_3[] = { 'Y' };
 static const symbol s_4[] = { 'y' };
-static const symbol s_5[] = { 'Y' };
-static const symbol s_6[] = { 'y' };
-static const symbol s_7[] = { 'u' };
-static const symbol s_8[] = { 'a' };
-static const symbol s_9[] = { 'o' };
-static const symbol s_10[] = { 'u' };
-static const symbol s_11[] = { 'i', 'g' };
-static const symbol s_12[] = { 'e' };
-static const symbol s_13[] = { 'e' };
-static const symbol s_14[] = { 'e', 'r' };
-static const symbol s_15[] = { 'e', 'n' };
+static const symbol s_5[] = { 'u' };
+static const symbol s_6[] = { 'a' };
+static const symbol s_7[] = { 'o' };
+static const symbol s_8[] = { 'n', 'i', 's' };
+static const symbol s_9[] = { 'i', 'g' };
+static const symbol s_10[] = { 'e', 'r' };
+static const symbol s_11[] = { 'e', 'n' };
 
-static int r_prelude(struct SN_env * z) {
-    {   int c_test = z->c; /* test, line 30 */
-        while(1) { /* repeat, line 30 */
-            int c1 = z->c;
-            {   int c2 = z->c; /* or, line 33 */
-                z->bra = z->c; /* [, line 32 */
-                if (!(eq_s(z, 2, s_0))) goto lab2;
-                z->ket = z->c; /* ], line 32 */
-                {   int ret = slice_from_s(z, 2, s_1); /* <-, line 32 */
+static int r_prelude(struct SN_env * z) { /* forwardmode */
+    {   int c_test1 = z->c; /* test, line 35 */
+        while(1) { /* repeat, line 35 */
+            int c2 = z->c;
+            {   int c3 = z->c; /* or, line 38 */
+                z->bra = z->c; /* [, line 37 */
+                if (!(eq_s(z, 2, s_0))) goto lab2; /* literal, line 37 */
+                z->ket = z->c; /* ], line 37 */
+                {   int ret = slice_from_s(z, 2, s_1); /* <-, line 37 */
                     if (ret < 0) return ret;
                 }
                 goto lab1;
             lab2:
-                z->c = c2;
+                z->c = c3;
                 {   int ret = skip_utf8(z->p, z->c, 0, z->l, 1);
                     if (ret < 0) goto lab0;
-                    z->c = ret; /* next, line 33 */
+                    z->c = ret; /* next, line 38 */
                 }
             }
         lab1:
             continue;
         lab0:
-            z->c = c1;
+            z->c = c2;
             break;
         }
-        z->c = c_test;
+        z->c = c_test1;
     }
-    while(1) { /* repeat, line 36 */
-        int c3 = z->c;
-        while(1) { /* goto, line 36 */
-            int c4 = z->c;
-            if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab4;
-            z->bra = z->c; /* [, line 37 */
-            {   int c5 = z->c; /* or, line 37 */
-                if (!(eq_s(z, 1, s_2))) goto lab6;
-                z->ket = z->c; /* ], line 37 */
-                if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab6;
-                {   int ret = slice_from_s(z, 1, s_3); /* <-, line 37 */
+    while(1) { /* repeat, line 41 */
+        int c4 = z->c;
+        while(1) { /* goto, line 41 */
+            int c5 = z->c;
+            if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab4; /* grouping v, line 42 */
+            z->bra = z->c; /* [, line 42 */
+            {   int c6 = z->c; /* or, line 42 */
+                if (z->c == z->l || z->p[z->c] != 'u') goto lab6; /* literal, line 42 */
+                z->c++;
+                z->ket = z->c; /* ], line 42 */
+                if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab6; /* grouping v, line 42 */
+                {   int ret = slice_from_s(z, 1, s_2); /* <-, line 42 */
                     if (ret < 0) return ret;
                 }
                 goto lab5;
             lab6:
-                z->c = c5;
-                if (!(eq_s(z, 1, s_4))) goto lab4;
-                z->ket = z->c; /* ], line 38 */
-                if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab4;
-                {   int ret = slice_from_s(z, 1, s_5); /* <-, line 38 */
+                z->c = c6;
+                if (z->c == z->l || z->p[z->c] != 'y') goto lab4; /* literal, line 43 */
+                z->c++;
+                z->ket = z->c; /* ], line 43 */
+                if (in_grouping_U(z, g_v, 97, 252, 0)) goto lab4; /* grouping v, line 43 */
+                {   int ret = slice_from_s(z, 1, s_3); /* <-, line 43 */
                     if (ret < 0) return ret;
                 }
             }
         lab5:
-            z->c = c4;
+            z->c = c5;
             break;
         lab4:
-            z->c = c4;
+            z->c = c5;
             {   int ret = skip_utf8(z->p, z->c, 0, z->l, 1);
                 if (ret < 0) goto lab3;
-                z->c = ret; /* goto, line 36 */
+                z->c = ret; /* goto, line 41 */
             }
         }
         continue;
     lab3:
-        z->c = c3;
+        z->c = c4;
         break;
     }
     return 1;
 }
 
-static int r_mark_regions(struct SN_env * z) {
-    z->I[0] = z->l;
-    z->I[1] = z->l;
-    {   int c_test = z->c; /* test, line 47 */
-        {   int ret = skip_utf8(z->p, z->c, 0, z->l, + 3);
+static int r_mark_regions(struct SN_env * z) { /* forwardmode */
+    z->I[0] = z->l; /* $p1 = <integer expression>, line 49 */
+    z->I[1] = z->l; /* $p2 = <integer expression>, line 50 */
+    {   int c_test1 = z->c; /* test, line 52 */
+        {   int ret = skip_utf8(z->p, z->c, 0, z->l, + 3); /* hop, line 52 */
             if (ret < 0) return 0;
-            z->c = ret; /* hop, line 47 */
+            z->c = ret;
         }
-        z->I[2] = z->c; /* setmark x, line 47 */
-        z->c = c_test;
+        z->I[2] = z->c; /* setmark x, line 52 */
+        z->c = c_test1;
     }
-    {    /* gopast */ /* grouping v, line 49 */
+    {    /* gopast */ /* grouping v, line 54 */
         int ret = out_grouping_U(z, g_v, 97, 252, 1);
         if (ret < 0) return 0;
         z->c += ret;
     }
-    {    /* gopast */ /* non v, line 49 */
+    {    /* gopast */ /* non v, line 54 */
         int ret = in_grouping_U(z, g_v, 97, 252, 1);
         if (ret < 0) return 0;
         z->c += ret;
     }
-    z->I[0] = z->c; /* setmark p1, line 49 */
-     /* try, line 50 */
-    if (!(z->I[0] < z->I[2])) goto lab0;
-    z->I[0] = z->I[2];
+    z->I[0] = z->c; /* setmark p1, line 54 */
+    /* try, line 55 */
+    if (!(z->I[0] < z->I[2])) goto lab0; /* $(<integer expression> < <integer expression>), line 55 */
+    z->I[0] = z->I[2]; /* $p1 = <integer expression>, line 55 */
 lab0:
-    {    /* gopast */ /* grouping v, line 51 */
+    {    /* gopast */ /* grouping v, line 56 */
         int ret = out_grouping_U(z, g_v, 97, 252, 1);
         if (ret < 0) return 0;
         z->c += ret;
     }
-    {    /* gopast */ /* non v, line 51 */
+    {    /* gopast */ /* non v, line 56 */
         int ret = in_grouping_U(z, g_v, 97, 252, 1);
         if (ret < 0) return 0;
         z->c += ret;
     }
-    z->I[1] = z->c; /* setmark p2, line 51 */
+    z->I[1] = z->c; /* setmark p2, line 56 */
     return 1;
 }
 
-static int r_postlude(struct SN_env * z) {
+static int r_postlude(struct SN_env * z) { /* forwardmode */
     int among_var;
-    while(1) { /* repeat, line 55 */
+    while(1) { /* repeat, line 60 */
         int c1 = z->c;
-        z->bra = z->c; /* [, line 57 */
-        among_var = find_among(z, a_0, 6); /* substring, line 57 */
+        z->bra = z->c; /* [, line 62 */
+        among_var = find_among(z, a_0, 6); /* substring, line 62 */
         if (!(among_var)) goto lab0;
-        z->ket = z->c; /* ], line 57 */
-        switch(among_var) {
-            case 0: goto lab0;
+        z->ket = z->c; /* ], line 62 */
+        switch (among_var) { /* among, line 62 */
             case 1:
-                {   int ret = slice_from_s(z, 1, s_6); /* <-, line 58 */
+                {   int ret = slice_from_s(z, 1, s_4); /* <-, line 63 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 2:
-                {   int ret = slice_from_s(z, 1, s_7); /* <-, line 59 */
+                {   int ret = slice_from_s(z, 1, s_5); /* <-, line 64 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 3:
-                {   int ret = slice_from_s(z, 1, s_8); /* <-, line 60 */
+                {   int ret = slice_from_s(z, 1, s_6); /* <-, line 65 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 4:
-                {   int ret = slice_from_s(z, 1, s_9); /* <-, line 61 */
+                {   int ret = slice_from_s(z, 1, s_7); /* <-, line 66 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 5:
-                {   int ret = slice_from_s(z, 1, s_10); /* <-, line 62 */
-                    if (ret < 0) return ret;
-                }
-                break;
-            case 6:
                 {   int ret = skip_utf8(z->p, z->c, 0, z->l, 1);
                     if (ret < 0) goto lab0;
-                    z->c = ret; /* next, line 63 */
+                    z->c = ret; /* next, line 68 */
                 }
                 break;
         }
@@ -287,38 +279,54 @@ static int r_postlude(struct SN_env * z) {
     return 1;
 }
 
-static int r_R1(struct SN_env * z) {
-    if (!(z->I[0] <= z->c)) return 0;
+static int r_R1(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[0] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 75 */
     return 1;
 }
 
-static int r_R2(struct SN_env * z) {
-    if (!(z->I[1] <= z->c)) return 0;
+static int r_R2(struct SN_env * z) { /* backwardmode */
+    if (!(z->I[1] <= z->c)) return 0; /* $(<integer expression> <= <integer expression>), line 76 */
     return 1;
 }
 
-static int r_standard_suffix(struct SN_env * z) {
+static int r_standard_suffix(struct SN_env * z) { /* backwardmode */
     int among_var;
-    {   int m1 = z->l - z->c; (void)m1; /* do, line 74 */
-        z->ket = z->c; /* [, line 75 */
-        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((811040 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab0;
-        among_var = find_among_b(z, a_1, 7); /* substring, line 75 */
+    {   int m1 = z->l - z->c; (void)m1; /* do, line 79 */
+        z->ket = z->c; /* [, line 80 */
+        if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((811040 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab0; /* substring, line 80 */
+        among_var = find_among_b(z, a_1, 7);
         if (!(among_var)) goto lab0;
-        z->bra = z->c; /* ], line 75 */
-        {   int ret = r_R1(z);
-            if (ret == 0) goto lab0; /* call R1, line 75 */
+        z->bra = z->c; /* ], line 80 */
+        {   int ret = r_R1(z); /* call R1, line 80 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
-        switch(among_var) {
-            case 0: goto lab0;
+        switch (among_var) { /* among, line 80 */
             case 1:
-                {   int ret = slice_del(z); /* delete, line 77 */
+                {   int ret = slice_del(z); /* delete, line 82 */
                     if (ret < 0) return ret;
                 }
                 break;
             case 2:
-                if (in_grouping_b_U(z, g_s_ending, 98, 116, 0)) goto lab0;
-                {   int ret = slice_del(z); /* delete, line 80 */
+                {   int ret = slice_del(z); /* delete, line 85 */
+                    if (ret < 0) return ret;
+                }
+                {   int m2 = z->l - z->c; (void)m2; /* try, line 86 */
+                    z->ket = z->c; /* [, line 86 */
+                    if (z->c <= z->lb || z->p[z->c - 1] != 's') { z->c = z->l - m2; goto lab1; } /* literal, line 86 */
+                    z->c--;
+                    z->bra = z->c; /* ], line 86 */
+                    if (!(eq_s_b(z, 3, s_8))) { z->c = z->l - m2; goto lab1; } /* literal, line 86 */
+                    {   int ret = slice_del(z); /* delete, line 86 */
+                        if (ret < 0) return ret;
+                    }
+                lab1:
+                    ;
+                }
+                break;
+            case 3:
+                if (in_grouping_b_U(z, g_s_ending, 98, 116, 0)) goto lab0; /* grouping s_ending, line 89 */
+                {   int ret = slice_del(z); /* delete, line 89 */
                     if (ret < 0) return ret;
                 }
                 break;
@@ -326,179 +334,171 @@ static int r_standard_suffix(struct SN_env * z) {
     lab0:
         z->c = z->l - m1;
     }
-    {   int m2 = z->l - z->c; (void)m2; /* do, line 84 */
-        z->ket = z->c; /* [, line 85 */
-        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1327104 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab1;
-        among_var = find_among_b(z, a_2, 4); /* substring, line 85 */
-        if (!(among_var)) goto lab1;
-        z->bra = z->c; /* ], line 85 */
-        {   int ret = r_R1(z);
-            if (ret == 0) goto lab1; /* call R1, line 85 */
-            if (ret < 0) return ret;
-        }
-        switch(among_var) {
-            case 0: goto lab1;
-            case 1:
-                {   int ret = slice_del(z); /* delete, line 87 */
-                    if (ret < 0) return ret;
-                }
-                break;
-            case 2:
-                if (in_grouping_b_U(z, g_st_ending, 98, 116, 0)) goto lab1;
-                {   int ret = skip_utf8(z->p, z->c, z->lb, z->l, - 3);
-                    if (ret < 0) goto lab1;
-                    z->c = ret; /* hop, line 90 */
-                }
-                {   int ret = slice_del(z); /* delete, line 90 */
-                    if (ret < 0) return ret;
-                }
-                break;
-        }
-    lab1:
-        z->c = z->l - m2;
-    }
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 94 */
-        z->ket = z->c; /* [, line 95 */
-        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1051024 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab2;
-        among_var = find_among_b(z, a_4, 8); /* substring, line 95 */
+    {   int m3 = z->l - z->c; (void)m3; /* do, line 93 */
+        z->ket = z->c; /* [, line 94 */
+        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1327104 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab2; /* substring, line 94 */
+        among_var = find_among_b(z, a_2, 4);
         if (!(among_var)) goto lab2;
-        z->bra = z->c; /* ], line 95 */
-        {   int ret = r_R2(z);
-            if (ret == 0) goto lab2; /* call R2, line 95 */
+        z->bra = z->c; /* ], line 94 */
+        {   int ret = r_R1(z); /* call R1, line 94 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
-        switch(among_var) {
-            case 0: goto lab2;
+        switch (among_var) { /* among, line 94 */
             case 1:
-                {   int ret = slice_del(z); /* delete, line 97 */
+                {   int ret = slice_del(z); /* delete, line 96 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 98 */
-                    z->ket = z->c; /* [, line 98 */
-                    if (!(eq_s_b(z, 2, s_11))) { z->c = z->l - m_keep; goto lab3; }
-                    z->bra = z->c; /* ], line 98 */
-                    {   int m4 = z->l - z->c; (void)m4; /* not, line 98 */
-                        if (!(eq_s_b(z, 1, s_12))) goto lab4;
-                        { z->c = z->l - m_keep; goto lab3; }
-                    lab4:
-                        z->c = z->l - m4;
-                    }
-                    {   int ret = r_R2(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab3; } /* call R2, line 98 */
-                        if (ret < 0) return ret;
-                    }
-                    {   int ret = slice_del(z); /* delete, line 98 */
-                        if (ret < 0) return ret;
-                    }
-                lab3:
-                    ;
-                }
                 break;
             case 2:
-                {   int m5 = z->l - z->c; (void)m5; /* not, line 101 */
-                    if (!(eq_s_b(z, 1, s_13))) goto lab5;
-                    goto lab2;
-                lab5:
-                    z->c = z->l - m5;
+                if (in_grouping_b_U(z, g_st_ending, 98, 116, 0)) goto lab2; /* grouping st_ending, line 99 */
+                {   int ret = skip_utf8(z->p, z->c, z->lb, z->l, - 3); /* hop, line 99 */
+                    if (ret < 0) goto lab2;
+                    z->c = ret;
                 }
-                {   int ret = slice_del(z); /* delete, line 101 */
+                {   int ret = slice_del(z); /* delete, line 99 */
                     if (ret < 0) return ret;
                 }
                 break;
-            case 3:
-                {   int ret = slice_del(z); /* delete, line 104 */
+        }
+    lab2:
+        z->c = z->l - m3;
+    }
+    {   int m4 = z->l - z->c; (void)m4; /* do, line 103 */
+        z->ket = z->c; /* [, line 104 */
+        if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((1051024 >> (z->p[z->c - 1] & 0x1f)) & 1)) goto lab3; /* substring, line 104 */
+        among_var = find_among_b(z, a_4, 8);
+        if (!(among_var)) goto lab3;
+        z->bra = z->c; /* ], line 104 */
+        {   int ret = r_R2(z); /* call R2, line 104 */
+            if (ret == 0) goto lab3;
+            if (ret < 0) return ret;
+        }
+        switch (among_var) { /* among, line 104 */
+            case 1:
+                {   int ret = slice_del(z); /* delete, line 106 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 105 */
-                    z->ket = z->c; /* [, line 106 */
-                    {   int m6 = z->l - z->c; (void)m6; /* or, line 106 */
-                        if (!(eq_s_b(z, 2, s_14))) goto lab8;
-                        goto lab7;
-                    lab8:
+                {   int m5 = z->l - z->c; (void)m5; /* try, line 107 */
+                    z->ket = z->c; /* [, line 107 */
+                    if (!(eq_s_b(z, 2, s_9))) { z->c = z->l - m5; goto lab4; } /* literal, line 107 */
+                    z->bra = z->c; /* ], line 107 */
+                    {   int m6 = z->l - z->c; (void)m6; /* not, line 107 */
+                        if (z->c <= z->lb || z->p[z->c - 1] != 'e') goto lab5; /* literal, line 107 */
+                        z->c--;
+                        { z->c = z->l - m5; goto lab4; }
+                    lab5:
                         z->c = z->l - m6;
-                        if (!(eq_s_b(z, 2, s_15))) { z->c = z->l - m_keep; goto lab6; }
                     }
-                lab7:
-                    z->bra = z->c; /* ], line 106 */
-                    {   int ret = r_R1(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab6; } /* call R1, line 106 */
+                    {   int ret = r_R2(z); /* call R2, line 107 */
+                        if (ret == 0) { z->c = z->l - m5; goto lab4; }
                         if (ret < 0) return ret;
                     }
-                    {   int ret = slice_del(z); /* delete, line 106 */
+                    {   int ret = slice_del(z); /* delete, line 107 */
                         if (ret < 0) return ret;
                     }
+                lab4:
+                    ;
+                }
+                break;
+            case 2:
+                {   int m7 = z->l - z->c; (void)m7; /* not, line 110 */
+                    if (z->c <= z->lb || z->p[z->c - 1] != 'e') goto lab6; /* literal, line 110 */
+                    z->c--;
+                    goto lab3;
                 lab6:
-                    ;
+                    z->c = z->l - m7;
                 }
-                break;
-            case 4:
                 {   int ret = slice_del(z); /* delete, line 110 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 111 */
-                    z->ket = z->c; /* [, line 112 */
-                    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 103 && z->p[z->c - 1] != 104)) { z->c = z->l - m_keep; goto lab9; }
-                    among_var = find_among_b(z, a_3, 2); /* substring, line 112 */
-                    if (!(among_var)) { z->c = z->l - m_keep; goto lab9; }
-                    z->bra = z->c; /* ], line 112 */
-                    {   int ret = r_R2(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab9; } /* call R2, line 112 */
+                break;
+            case 3:
+                {   int ret = slice_del(z); /* delete, line 113 */
+                    if (ret < 0) return ret;
+                }
+                {   int m8 = z->l - z->c; (void)m8; /* try, line 114 */
+                    z->ket = z->c; /* [, line 115 */
+                    {   int m9 = z->l - z->c; (void)m9; /* or, line 115 */
+                        if (!(eq_s_b(z, 2, s_10))) goto lab9; /* literal, line 115 */
+                        goto lab8;
+                    lab9:
+                        z->c = z->l - m9;
+                        if (!(eq_s_b(z, 2, s_11))) { z->c = z->l - m8; goto lab7; } /* literal, line 115 */
+                    }
+                lab8:
+                    z->bra = z->c; /* ], line 115 */
+                    {   int ret = r_R1(z); /* call R1, line 115 */
+                        if (ret == 0) { z->c = z->l - m8; goto lab7; }
+                        if (ret < 0) return ret;
+                    }
+                    {   int ret = slice_del(z); /* delete, line 115 */
                         if (ret < 0) return ret;
                     }
-                    switch(among_var) {
-                        case 0: { z->c = z->l - m_keep; goto lab9; }
-                        case 1:
-                            {   int ret = slice_del(z); /* delete, line 114 */
-                                if (ret < 0) return ret;
-                            }
-                            break;
+                lab7:
+                    ;
+                }
+                break;
+            case 4:
+                {   int ret = slice_del(z); /* delete, line 119 */
+                    if (ret < 0) return ret;
+                }
+                {   int m10 = z->l - z->c; (void)m10; /* try, line 120 */
+                    z->ket = z->c; /* [, line 121 */
+                    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 103 && z->p[z->c - 1] != 104)) { z->c = z->l - m10; goto lab10; } /* substring, line 121 */
+                    if (!(find_among_b(z, a_3, 2))) { z->c = z->l - m10; goto lab10; }
+                    z->bra = z->c; /* ], line 121 */
+                    {   int ret = r_R2(z); /* call R2, line 121 */
+                        if (ret == 0) { z->c = z->l - m10; goto lab10; }
+                        if (ret < 0) return ret;
+                    }
+                    {   int ret = slice_del(z); /* delete, line 123 */
+                        if (ret < 0) return ret;
                     }
-                lab9:
+                lab10:
                     ;
                 }
                 break;
         }
-    lab2:
-        z->c = z->l - m3;
+    lab3:
+        z->c = z->l - m4;
     }
     return 1;
 }
 
-extern int german_UTF_8_stem(struct SN_env * z) {
-    {   int c1 = z->c; /* do, line 125 */
-        {   int ret = r_prelude(z);
-            if (ret == 0) goto lab0; /* call prelude, line 125 */
+extern int german_UTF_8_stem(struct SN_env * z) { /* forwardmode */
+    {   int c1 = z->c; /* do, line 134 */
+        {   int ret = r_prelude(z); /* call prelude, line 134 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = c1;
     }
-    {   int c2 = z->c; /* do, line 126 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab1; /* call mark_regions, line 126 */
+    {   int c2 = z->c; /* do, line 135 */
+        {   int ret = r_mark_regions(z); /* call mark_regions, line 135 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = c2;
     }
-    z->lb = z->c; z->c = z->l; /* backwards, line 127 */
+    z->lb = z->c; z->c = z->l; /* backwards, line 136 */
 
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 128 */
-        {   int ret = r_standard_suffix(z);
-            if (ret == 0) goto lab2; /* call standard_suffix, line 128 */
-            if (ret < 0) return ret;
-        }
-    lab2:
-        z->c = z->l - m3;
+    /* do, line 137 */
+    {   int ret = r_standard_suffix(z); /* call standard_suffix, line 137 */
+        if (ret == 0) goto lab2;
+        if (ret < 0) return ret;
     }
+lab2:
     z->c = z->lb;
-    {   int c4 = z->c; /* do, line 129 */
-        {   int ret = r_postlude(z);
-            if (ret == 0) goto lab3; /* call postlude, line 129 */
+    {   int c3 = z->c; /* do, line 138 */
+        {   int ret = r_postlude(z); /* call postlude, line 138 */
+            if (ret == 0) goto lab3;
             if (ret < 0) return ret;
         }
     lab3:
-        z->c = c4;
+        z->c = c3;
     }
     return 1;
 }
